#include "rtp/orientation.hh"

#include <iostream>

#define deg(X) ((X) * (M_PI / 180.))

int main()
{
  RTP vector<double,2>      v1(1.0, 0.0), v2(0.0, 1.0), v3(1.0, 1.0), v4(1.0, 2.0);
  RTP orientation<double,2> o1(deg(30.0));

#define P(X) std::cout << #X << " = " << (X) << "\n"

  P(v1);
  P(v2);
  P(v3);
  P(v4);
  P(o1);

  P(o1 * v1);
  P(v1 * o1);

  P(o1 / v1);
  P(v1 / o1);

  P(o1 / (o1 * v1));
  P(o1 * o1);
  P(o1 * o1 * v1);
  P(o1 / o1);

  P(o1 * v2);
  P(o1 * v3);
  P(o1 / (o1 * v3));
  P(o1 * v4);
  P(o1 / (o1 * v4));

#undef P

  return 0;
}
