#include "rtp/mat.hh"

#include <iostream>

#define deg(X) ((X) * (M_PI / 180.))

int main()
{
  RTP mat<double,2,2>      m0(0.0), m1(1.0);
  RTP mat<double,3,3>      m2(1.0), m3(2.0);
  RTP vec<double,2>        v0(1.0, 2.0), v1(3.0, 4.0);
  RTP vec<double,3>        v2(1.0, 2.0, 3.0), v3(4.0, 5.0, 6.0);

#define P(X) std::cout << #X << " = " << (X) << "\n"

  P(m0);
  P(m1);
  P(m2);
  P(m3);
  P(v0);
  P(v1);
  P(v2);
  P(v3);

  P(m1 + m1);
  P(- m1);

  P(v0 * m1);
  P(v1 * m0);
  P(m2 * m3);

#undef P

  return 0;
}
