#include "rtp/frame.hh"

#include <iostream>

#define deg(X) ((X) * (M_PI / 180.))

int main()
{
  RTP location<double,2>     f0o(0.0, 0.0), f1o(1.0, 2.0);
  RTP orientation<double,2>  f0r(0.0),      f1r(deg(30));

  RTP frame<double,2>        f0(f0o, f0r);
  RTP frame<double,2>        f1(f1o, f1r);

  RTP vector<double,2>       v0(0.0), v1(1, 1);
  //  RTP vector<double,2>       v0p, v1p;
  RTP location<double,2>     l0(0.0), l1(1, 2);
  //  RTP location<double,2>     l0p, l1p;

#define P(X) std::cout << #X << " = " << (X) << "\n"
#define Pv(X) do { std::cout << #X << "\n"; X; } while(0)

  P(f0o);
  P(f0r);
  P(f0);
  P(f1o);
  P(f1r);
  P(f1);

  P(v0);
  P(v1);
  P(l0);
  P(l1);

  P(v0.rep(&f0));
  P(v1.rep(&f0));

  P(l0.rep(&f0));
  P(l1.rep(&f0));

  P(v0.rep(&f1));
  P(v1.rep(&f1));

  P(l0.rep(&f1));
  P(l1.rep(&f1));

#undef P

  return 0;
}
